#ifndef MOG2_CONDITION_SCRIPTS
#define MOG2_CONDITION_SCRIPTS

#define CONDITION_CMD_DELETE		-1

#define CONDITION_CMD_TRUE					0
#define CONDITION_CMD_FALSE					1

#define CONDITION_CMD_NOT					2
#define CONDITION_CMD_AND					3
#define CONDITION_CMD_OR					4

#define CONDITION_CMD_TIMMER				5
#define CONDITION_CMD_COLLISION				6
#define CONDITION_CMD_COLLISION_WITH_OBJECT	17
#define CONDITION_CMD_INSIDE_ROOM			7
#define CONDITION_CMD_PARTIALLY_INSIDE_ROOM	16
#define CONDITION_CMD_SENSE_OBJECT			15
#define CONDITION_CMD_SENSE_SPECIFIC_OBJECT	21

#define CONDITION_CMD_KEYPRESS				8
#define CONDITION_CMD_KEYPRESSED			9

#define CONDITION_CMD_VARIABLE_EQ			10
#define CONDITION_CMD_VARIABLE_GR			11
#define CONDITION_CMD_VARIABLE_GREQ			12
#define CONDITION_CMD_VARIABLE_LW			13
#define CONDITION_CMD_VARIABLE_LWEQ			14

#define CONDITION_CMD_FIND_SUBSTRING		18

#define CONDITION_CMD_INVINCIBLE			19
#define CONDITION_CMD_INLADDER				20

#define CONDITION_CMD_H_COLLISION				22
#define CONDITION_CMD_H_COLLISION_WITH_OBJECT	23
#define CONDITION_CMD_H_INSIDE_ROOM				24
#define CONDITION_CMD_H_PARTIALLY_INSIDE_ROOM	25

#define CONDITION_CMD_LOADGAME				26
#define CONDITION_CMD_SAVEGAME				27

#define CONDITION_CMD_VALID_OBJECT			28


#define CONDITION_MAX_CMD					29

#define MAX_CONDITION_PARAMETERS			6

class ConditionSCRIPT {
	friend class BViewActionScriptWnd;
	friend class BViewConditionScriptWnd;
	friend class GameDebugWindow;
	friend class BScriptDebugWnd;

public:
	ConditionSCRIPT(void);
	ConditionSCRIPT(ConditionSCRIPT &s);
	~ConditionSCRIPT(void);

	bool load(FILE *fp,class MOG2 *game);
	bool save(FILE *fp);

	char *generate_string(void);

	void init(void);
	bool cycle(class ActiveOBJECT *o,class ActiveROOM *r,class ActiveMAP *map,class ActiveMOG2 *game,class ActiveINTERFACE *interf,class ActiveMOG2Application *app,ActiveOBJECT **foreign_object,int location,class KEYBOARDSTATE **LVK,int n_LVKs);

	void copy_state(ConditionSCRIPT *s);
	void simplify(void);

	bool uses_sample(class SAMPLE *s);

private:

	int timmer;

	int command;
	class ValueSCRIPT *vpar[MAX_CONDITION_PARAMETERS];
	List<ConditionSCRIPT> aparlist;

	int dx,dy; /* Size of the printed SCRIPT, for the edit windows.	*/ 
};


#endif

